diff --git a/debian/control.stub b/debian/control.stub
index 39114e8..2b5b416 100644
--- a/debian/control.stub
+++ b/debian/control.stub
@@ -62,13 +62,13 @@ Depends: ${misc:Depends}, linux-modules-nvidia-390-ABI-lowlatency (= ${binary:Ve
 Description: Extra drivers for nvidia-390 for the lowlatency flavour
  Install extra signed nvidia-390 modules compatible with the lowlatency flavour.

-Package: linux-modules-nvidia-430-ABI-generic
+Package: linux-modules-nvidia-440-ABI-generic
 Build-Profiles: <!stage1>
 Architecture: amd64
 Section: kernel
 Priority: optional
 Built-Using: ${linux:BuiltUsing}
-Depends: ${misc:Depends}, ${shlibs:Depends}, binutils, linux-image-ABI-generic | linux-image-unsigned-ABI-generic, nvidia-kernel-common-430
+Depends: ${misc:Depends}, ${shlibs:Depends}, binutils, linux-image-ABI-generic | linux-image-unsigned-ABI-generic, nvidia-kernel-common-440
 Description: Linux kernel nvidia modules for version ABI
  This package contains the Linux kernel nvidia modules for version ABI.
  .
@@ -76,13 +76,13 @@ Description: Linux kernel nvidia modules for version ABI
  linux-image-nvidia-FLAVOUR meta-package, which will ensure that upgrades work
  correctly, and that supporting packages are also installed.

-Package: linux-modules-nvidia-430-ABI-lowlatency
+Package: linux-modules-nvidia-440-ABI-lowlatency
 Build-Profiles: <!stage1>
 Architecture: amd64
 Section: kernel
 Priority: optional
 Built-Using: ${linux:BuiltUsing}
-Depends: ${misc:Depends}, ${shlibs:Depends}, binutils, linux-image-ABI-lowlatency | linux-image-unsigned-ABI-lowlatency, nvidia-kernel-common-430
+Depends: ${misc:Depends}, ${shlibs:Depends}, binutils, linux-image-ABI-lowlatency | linux-image-unsigned-ABI-lowlatency, nvidia-kernel-common-440
 Description: Linux kernel nvidia modules for version ABI
  This package contains the Linux kernel nvidia modules for version ABI.
  .
@@ -90,21 +90,61 @@ Description: Linux kernel nvidia modules for version ABI
  linux-image-nvidia-FLAVOUR meta-package, which will ensure that upgrades work
  correctly, and that supporting packages are also installed.

+Package: linux-modules-nvidia-440-generic
+Build-Profiles: <!stage1>
+Architecture: amd64
+Section: kernel
+Depends: ${misc:Depends}, linux-modules-nvidia-440-ABI-generic (= ${binary:Version})
+Description: Extra drivers for nvidia-440 for the generic flavour
+ Install extra signed nvidia-440 modules compatible with the generic flavour.
+
+Package: linux-modules-nvidia-440-lowlatency
+Build-Profiles: <!stage1>
+Architecture: amd64
+Section: kernel
+Depends: ${misc:Depends}, linux-modules-nvidia-440-ABI-lowlatency (= ${binary:Version})
+Description: Extra drivers for nvidia-440 for the lowlatency flavour
+ Install extra signed nvidia-440 modules compatible with the lowlatency flavour.
+
+Package: linux-modules-nvidia-430-ABI-generic
+Build-Profiles: <!stage1>
+Architecture: amd64
+Section: kernel
+Priority: optional
+Built-Using: ${linux:BuiltUsing}
+Depends: linux-modules-nvidia-440-ABI-generic
+Description: Transitional package for linux-modules-nvidia-440-ABI-generic
+ This is a transitional package for linux-modules-nvidia-440-ABI-generic, and can be
+ safely removed after the installation is complete.
+
+Package: linux-modules-nvidia-430-ABI-lowlatency
+Build-Profiles: <!stage1>
+Architecture: amd64
+Section: kernel
+Priority: optional
+Built-Using: ${linux:BuiltUsing}
+Depends: linux-modules-nvidia-440-ABI-lowlatency
+Description: Transitional package for linux-modules-nvidia-440-ABI-lowlatency
+ This is a transitional package for linux-modules-nvidia-440-ABI-lowlatency, and can be
+ safely removed after the installation is complete.
+
 Package: linux-modules-nvidia-430-generic
 Build-Profiles: <!stage1>
 Architecture: amd64
 Section: kernel
-Depends: ${misc:Depends}, linux-modules-nvidia-430-ABI-generic (= ${binary:Version})
-Description: Extra drivers for nvidia-430 for the generic flavour
- Install extra signed nvidia-430 modules compatible with the generic flavour.
+Depends: linux-modules-nvidia-440-generic
+Description: Transitional package for linux-modules-nvidia-440-generic
+ This is a transitional package for linux-modules-nvidia-440-generic, and can be
+ safely removed after the installation is complete.

 Package: linux-modules-nvidia-430-lowlatency
 Build-Profiles: <!stage1>
 Architecture: amd64
 Section: kernel
-Depends: ${misc:Depends}, linux-modules-nvidia-430-ABI-lowlatency (= ${binary:Version})
-Description: Extra drivers for nvidia-430 for the lowlatency flavour
- Install extra signed nvidia-430 modules compatible with the lowlatency flavour.
+Depends: linux-modules-nvidia-440-lowlatency
+Description: Transitional package for linux-modules-nvidia-440-lowlatency
+ This is a transitional package for linux-modules-nvidia-440-lowlatency, and can be
+ safely removed after the installation is complete.

 Package: linux-modules-nvidia-435-ABI-generic
 Build-Profiles: <!stage1>
diff --git a/debian/rules b/debian/rules
index 54040a5..a81226c 100755
--- a/debian/rules
+++ b/debian/rules
@@ -15,7 +15,7 @@ src_version = $(shell echo $(src_fullversion) | sed -e 's/+[0-9][0-9]*//')
 series = $(shell dpkg-parsechangelog | sed -ne 's/^Distribution: *//p' | sed -e 's/-\(security\|updates\|proposed\)$$//')

 dkms_nvidia_390_version=$(shell gawk '/^nvidia-graphics-drivers-390/ { print $$2; }' debian/dkms-versions)
-dkms_nvidia_430_version=$(shell gawk '/^nvidia-graphics-drivers-430/ { print $$2; }' debian/dkms-versions)
+dkms_nvidia_440_version=$(shell gawk '/^nvidia-graphics-drivers-440/ { print $$2; }' debian/dkms-versions)
 dkms_nvidia_435_version=$(shell gawk '/^nvidia-graphics-drivers-435/ { print $$2; }' debian/dkms-versions)

 test:
@@ -94,10 +94,10 @@ nvidia-%:
 	$(call build_dkms, $(src_abi)-$*, linux-modules-nvidia-390-$(src_abi)-$*, $(CURDIR)/debian/linux-modules-nvidia-390-$(src_abi)-$*/lib/modules/$(src_abi)-$*/kernel, "", nvidia-390, pool/restricted/n/nvidia-graphics-drivers-390/nvidia-kernel-source-390_$(dkms_nvidia_390_version)_$(arch).deb pool/restricted/n/nvidia-graphics-drivers-390/nvidia-dkms-390_$(dkms_nvidia_390_version)_$(arch).deb)
 	$(call install_control,linux-modules-nvidia-390-$(src_abi)-$*,$*,nvidia,390,postinst postrm prerm config templates)

-	install -d debian/linux-modules-nvidia-430-$(src_abi)-$*
-	install -d debian/linux-modules-nvidia-430-$(src_abi)-$*/usr/lib/linux/triggers
-	$(call build_dkms, $(src_abi)-$*, linux-modules-nvidia-430-$(src_abi)-$*, $(CURDIR)/debian/linux-modules-nvidia-430-$(src_abi)-$*/lib/modules/$(src_abi)-$*/kernel, "", nvidia-430, pool/restricted/n/nvidia-graphics-drivers-430/nvidia-kernel-source-430_$(dkms_nvidia_430_version)_$(arch).deb pool/restricted/n/nvidia-graphics-drivers-430/nvidia-dkms-430_$(dkms_nvidia_430_version)_$(arch).deb)
-	$(call install_control,linux-modules-nvidia-430-$(src_abi)-$*,$*,nvidia,430,postinst postrm prerm config templates)
+	install -d debian/linux-modules-nvidia-440-$(src_abi)-$*
+	install -d debian/linux-modules-nvidia-440-$(src_abi)-$*/usr/lib/linux/triggers
+	$(call build_dkms, $(src_abi)-$*, linux-modules-nvidia-440-$(src_abi)-$*, $(CURDIR)/debian/linux-modules-nvidia-440-$(src_abi)-$*/lib/modules/$(src_abi)-$*/kernel, "", nvidia-440, pool/restricted/n/nvidia-graphics-drivers-440/nvidia-kernel-source-440_$(dkms_nvidia_440_version)_$(arch).deb pool/restricted/n/nvidia-graphics-drivers-440/nvidia-dkms-440_$(dkms_nvidia_440_version)_$(arch).deb)
+	$(call install_control,linux-modules-nvidia-440-$(src_abi)-$*,$*,nvidia,440,postinst postrm prerm config templates)

 	install -d debian/linux-modules-nvidia-435-$(src_abi)-$*
 	install -d debian/linux-modules-nvidia-435-$(src_abi)-$*/usr/lib/linux/triggers