diff --git a/debian/control.stub b/debian/control.stub
index b974f24..d0d2a2c 100644
--- a/debian/control.stub
+++ b/debian/control.stub
@@ -114,7 +114,7 @@ Depends: ${misc:Depends}, linux-modules-nvidia-435-ABI-lowlatency (= ${binary:Ve
 Description: Extra drivers for nvidia-435 for the lowlatency flavour
  Install extra signed nvidia-435 modules compatible with the lowlatency flavour.
 
-Package: linux-modules-nvidia-440-ABI-generic
+Package: linux-modules-nvidia-450-ABI-generic
 Build-Profiles: <!stage1>
 Architecture: amd64
 Section: kernel
@@ -128,7 +128,7 @@ Description: Linux kernel nvidia modules for version ABI
  linux-image-nvidia-FLAVOUR meta-package, which will ensure that upgrades work
  correctly, and that supporting packages are also installed.
 
-Package: linux-modules-nvidia-440-ABI-lowlatency
+Package: linux-modules-nvidia-450-ABI-lowlatency
 Build-Profiles: <!stage1>
 Architecture: amd64
 Section: kernel
@@ -142,25 +142,25 @@ Description: Linux kernel nvidia modules for version ABI
  linux-image-nvidia-FLAVOUR meta-package, which will ensure that upgrades work
  correctly, and that supporting packages are also installed.
 
-Package: linux-modules-nvidia-440-generic
+Package: linux-modules-nvidia-450-generic
 Build-Profiles: <!stage1>
 Architecture: amd64
 Section: kernel
-Provides: ${dkms:nvidia-440-modules}
-Depends: ${misc:Depends}, linux-modules-nvidia-440-ABI-generic (= ${binary:Version}),
- ${nvk:nvidia-440}
-Description: Extra drivers for nvidia-440 for the generic flavour
- Install extra signed nvidia-440 modules compatible with the generic flavour.
+Provides: ${dkms:nvidia-450-modules}
+Depends: ${misc:Depends}, linux-modules-nvidia-450-ABI-generic (= ${binary:Version}),
+ ${nvk:nvidia-450}
+Description: Extra drivers for nvidia-450 for the generic flavour
+ Install extra signed nvidia-450 modules compatible with the generic flavour.
 
-Package: linux-modules-nvidia-440-lowlatency
+Package: linux-modules-nvidia-450-lowlatency
 Build-Profiles: <!stage1>
 Architecture: amd64
 Section: kernel
-Provides: ${dkms:nvidia-440-modules}
-Depends: ${misc:Depends}, linux-modules-nvidia-440-ABI-lowlatency (= ${binary:Version}),
- ${nvk:nvidia-440}
-Description: Extra drivers for nvidia-440 for the lowlatency flavour
- Install extra signed nvidia-440 modules compatible with the lowlatency flavour.
+Provides: ${dkms:nvidia-450-modules}
+Depends: ${misc:Depends}, linux-modules-nvidia-450-ABI-lowlatency (= ${binary:Version}),
+ ${nvk:nvidia-450}
+Description: Extra drivers for nvidia-450 for the lowlatency flavour
+ Install extra signed nvidia-450 modules compatible with the lowlatency flavour.
 
 Package: linux-modules-nvidia-418-server-ABI-generic
 Build-Profiles: <!stage1>
@@ -257,3 +257,65 @@ Depends: ${misc:Depends}, linux-modules-nvidia-440-server-ABI-lowlatency (= ${bi
  ${nvk:nvidia-440-server}
 Description: Extra drivers for nvidia-440-server for the lowlatency flavour
  Install extra signed nvidia-440-server modules compatible with the lowlatency flavour.
+
+Package: linux-modules-nvidia-450-server-ABI-generic
+Build-Profiles: <!stage1>
+Architecture: amd64
+Section: kernel
+Priority: optional
+Built-Using: ${linux:BuiltUsing}
+Depends: ${misc:Depends}, ${shlibs:Depends}, binutils, linux-image-ABI-generic | linux-image-unsigned-ABI-generic,
+Description: Linux kernel nvidia modules for version ABI
+ This package contains the Linux kernel nvidia modules for version ABI.
+ .
+ You likely do not want to install this package directly. Instead, install the
+ linux-image-nvidia-FLAVOUR meta-package, which will ensure that upgrades work
+ correctly, and that supporting packages are also installed.
+
+Package: linux-modules-nvidia-450-server-ABI-lowlatency
+Build-Profiles: <!stage1>
+Architecture: amd64
+Section: kernel
+Priority: optional
+Built-Using: ${linux:BuiltUsing}
+Depends: ${misc:Depends}, ${shlibs:Depends}, binutils, linux-image-ABI-lowlatency | linux-image-unsigned-ABI-lowlatency,
+Description: Linux kernel nvidia modules for version ABI
+ This package contains the Linux kernel nvidia modules for version ABI.
+ .
+ You likely do not want to install this package directly. Instead, install the
+ linux-image-nvidia-FLAVOUR meta-package, which will ensure that upgrades work
+ correctly, and that supporting packages are also installed.
+
+Package: linux-modules-nvidia-450-server-generic
+Build-Profiles: <!stage1>
+Architecture: amd64
+Section: kernel
+Provides: ${dkms:nvidia-450-server-modules}
+Depends: ${misc:Depends}, linux-modules-nvidia-450-server-ABI-generic (= ${binary:Version}),
+ ${nvk:nvidia-450-server}
+Description: Extra drivers for nvidia-450-server for the generic flavour
+ Install extra signed nvidia-450-server modules compatible with the generic flavour.
+
+Package: linux-modules-nvidia-450-server-lowlatency
+Build-Profiles: <!stage1>
+Architecture: amd64
+Section: kernel
+Provides: ${dkms:nvidia-450-server-modules}
+Depends: ${misc:Depends}, linux-modules-nvidia-450-server-ABI-lowlatency (= ${binary:Version}),
+ ${nvk:nvidia-450-server}
+Description: Extra drivers for nvidia-450-server for the lowlatency flavour
+ Install extra signed nvidia-450-server modules compatible with the lowlatency flavour.
+
+Package: linux-modules-nvidia-440-generic
+Architecture: amd64
+Section: oldlibs
+Depends: linux-modules-nvidia-450-generic
+Description: Extra drivers for nvidia-440 for the generic flavour (dummy transitional package)
+ Transitional package for upgrades of -440 to -450.
+
+Package: linux-modules-nvidia-440-lowlatency
+Architecture: amd64
+Section: oldlibs
+Depends: linux-modules-nvidia-450-lowlatency
+Description: Extra drivers for nvidia-440 for the generic flavour (dummy transitional package)
+ Transitional package for upgrades of -440 to -450.
diff --git a/debian/dkms-versions b/debian/dkms-versions
index 0f282cc..48c2140 100644
--- a/debian/dkms-versions
+++ b/debian/dkms-versions
@@ -2,7 +2,8 @@ spl-linux 0.7.5-1ubuntu2.2
 zfs-linux 0.7.5-1ubuntu16.9
 nvidia-graphics-drivers-390 390.138-0ubuntu0.18.04.1
 nvidia-graphics-drivers-435 435.21-0ubuntu0.18.04.3
-nvidia-graphics-drivers-440 440.100-0ubuntu0.18.04.1
+nvidia-graphics-drivers-450 0
 nvidia-graphics-drivers-418-server 418.152.00-0ubuntu0.18.04.1
 nvidia-graphics-drivers-440-server 440.95.01-0ubuntu0.18.04.1
+nvidia-graphics-drivers-450-server 0
 wireguard-linux-compat 1.0.20200611-1ubuntu1~18.04.1
diff --git a/debian/rules b/debian/rules
index 210465a..ef219b3 100755
--- a/debian/rules
+++ b/debian/rules
@@ -15,15 +15,17 @@ src_version = $(shell echo $(src_fullversion) | sed -e 's/+[0-9][0-9]*//')
 
 dkms_nvidia_390_version=$(shell gawk '/^nvidia-graphics-drivers-390 / { print $$2; }' debian/dkms-versions)
 dkms_nvidia_435_version=$(shell gawk '/^nvidia-graphics-drivers-435 / { print $$2; }' debian/dkms-versions)
-dkms_nvidia_440_version=$(shell gawk '/^nvidia-graphics-drivers-440 / { print $$2; }' debian/dkms-versions)
+dkms_nvidia_450_version=$(shell gawk '/^nvidia-graphics-drivers-450 / { print $$2; }' debian/dkms-versions)
 dkms_nvidia_418_server_version=$(shell gawk '/^nvidia-graphics-drivers-418-server / { print $$2; }' debian/dkms-versions)
 dkms_nvidia_440_server_version=$(shell gawk '/^nvidia-graphics-drivers-440-server / { print $$2; }' debian/dkms-versions)
+dkms_nvidia_450_server_version=$(shell gawk '/^nvidia-graphics-drivers-450-server / { print $$2; }' debian/dkms-versions)
 
 nvidia_390_upstream_version=$(shell echo "$(dkms_nvidia_390_version)" | cut -d '-' -f 1)
 nvidia_435_upstream_version=$(shell echo "$(dkms_nvidia_435_version)" | cut -d '-' -f 1)
-nvidia_440_upstream_version=$(shell echo "$(dkms_nvidia_440_version)" | cut -d '-' -f 1)
+nvidia_450_upstream_version=$(shell echo "$(dkms_nvidia_450_version)" | cut -d '-' -f 1)
 nvidia_418_server_upstream_version=$(shell echo "$(dkms_nvidia_418_server_version)" | cut -d '-' -f 1)
 nvidia_440_server_upstream_version=$(shell echo "$(dkms_nvidia_440_server_version)" | cut -d '-' -f 1)
+nvidia_450_server_upstream_version=$(shell echo "$(dkms_nvidia_450_server_version)" | cut -d '-' -f 1)
 
 test:
 	echo "$(src_fullversion) $(src_version)"
@@ -105,10 +107,10 @@ nvidia-%:
 	$(call build_dkms, $(src_abi)-$*, linux-modules-nvidia-435-$(src_abi)-$*, $(CURDIR)/debian/linux-modules-nvidia-435-$(src_abi)-$*/lib/modules/$(src_abi)-$*/kernel, nvidia-435, pool/restricted/n/nvidia-graphics-drivers-435/nvidia-kernel-source-435_$(dkms_nvidia_435_version)_$(arch).deb pool/restricted/n/nvidia-graphics-drivers-435/nvidia-dkms-435_$(dkms_nvidia_435_version)_$(arch).deb)
 	$(call install_control,linux-modules-nvidia-435-$(src_abi)-$*,$*,nvidia,435,postinst postrm prerm config templates)
 
-	install -d debian/linux-modules-nvidia-440-$(src_abi)-$*
-	install -d debian/linux-modules-nvidia-440-$(src_abi)-$*/usr/lib/linux/triggers
-	$(call build_dkms, $(src_abi)-$*, linux-modules-nvidia-440-$(src_abi)-$*, $(CURDIR)/debian/linux-modules-nvidia-440-$(src_abi)-$*/lib/modules/$(src_abi)-$*/kernel, nvidia-440, pool/restricted/n/nvidia-graphics-drivers-440/nvidia-kernel-source-440_$(dkms_nvidia_440_version)_$(arch).deb pool/restricted/n/nvidia-graphics-drivers-440/nvidia-dkms-440_$(dkms_nvidia_440_version)_$(arch).deb)
-	$(call install_control,linux-modules-nvidia-440-$(src_abi)-$*,$*,nvidia,440,postinst postrm prerm config templates)
+	install -d debian/linux-modules-nvidia-450-$(src_abi)-$*
+	install -d debian/linux-modules-nvidia-450-$(src_abi)-$*/usr/lib/linux/triggers
+	$(call build_dkms, $(src_abi)-$*, linux-modules-nvidia-450-$(src_abi)-$*, $(CURDIR)/debian/linux-modules-nvidia-450-$(src_abi)-$*/lib/modules/$(src_abi)-$*/kernel, nvidia-450, pool/restricted/n/nvidia-graphics-drivers-450/nvidia-kernel-source-450_$(dkms_nvidia_450_version)_$(arch).deb pool/restricted/n/nvidia-graphics-drivers-450/nvidia-dkms-450_$(dkms_nvidia_450_version)_$(arch).deb)
+	$(call install_control,linux-modules-nvidia-450-$(src_abi)-$*,$*,nvidia,450,postinst postrm prerm config templates)
 
 	install -d debian/linux-modules-nvidia-418-server-$(src_abi)-$*
 	install -d debian/linux-modules-nvidia-418-server-$(src_abi)-$*/usr/lib/linux/triggers
@@ -120,6 +122,11 @@ nvidia-%:
 	$(call build_dkms, $(src_abi)-$*, linux-modules-nvidia-440-server-$(src_abi)-$*, $(CURDIR)/debian/linux-modules-nvidia-440-server-$(src_abi)-$*/lib/modules/$(src_abi)-$*/kernel, nvidia-440srv, pool/restricted/n/nvidia-graphics-drivers-440-server/nvidia-kernel-source-440-server_$(dkms_nvidia_440_server_version)_$(arch).deb pool/restricted/n/nvidia-graphics-drivers-440-server/nvidia-dkms-440-server_$(dkms_nvidia_440_server_version)_$(arch).deb)
 	$(call install_control,linux-modules-nvidia-440-server-$(src_abi)-$*,$*,nvidia,440srv,postinst postrm prerm config templates)
 
+	install -d debian/linux-modules-nvidia-450-server-$(src_abi)-$*
+	install -d debian/linux-modules-nvidia-450-server-$(src_abi)-$*/usr/lib/linux/triggers
+	$(call build_dkms, $(src_abi)-$*, linux-modules-nvidia-450-server-$(src_abi)-$*, $(CURDIR)/debian/linux-modules-nvidia-450-server-$(src_abi)-$*/lib/modules/$(src_abi)-$*/kernel, nvidia-450srv, pool/restricted/n/nvidia-graphics-drivers-450-server/nvidia-kernel-source-450-server_$(dkms_nvidia_450_server_version)_$(arch).deb pool/restricted/n/nvidia-graphics-drivers-450-server/nvidia-dkms-450-server_$(dkms_nvidia_450_server_version)_$(arch).deb)
+	$(call install_control,linux-modules-nvidia-450-server-$(src_abi)-$*,$*,nvidia,450srv,postinst postrm prerm config templates)
+
 prepare-dkms:
 	mkdir -p $(dkms_dir)
 	ln -s /usr/src $(dkms_dir)/headers
@@ -129,15 +136,17 @@ override_dh_auto_install: prepare-dkms $(flavours)
 
 gencontrol_flags  = -Vdkms:nvidia-390-modules="nvidia-dkms-390 (= $(dkms_nvidia_390_version))"
 gencontrol_flags += -Vdkms:nvidia-435-modules="nvidia-dkms-435 (= $(dkms_nvidia_435_version))"
-gencontrol_flags += -Vdkms:nvidia-440-modules="nvidia-dkms-440 (= $(dkms_nvidia_440_version))"
+gencontrol_flags += -Vdkms:nvidia-450-modules="nvidia-dkms-450 (= $(dkms_nvidia_450_version))"
 gencontrol_flags += -Vdkms:nvidia-418-server-modules="nvidia-dkms-418-server (= $(dkms_nvidia_418_server_version))"
 gencontrol_flags += -Vdkms:nvidia-440-server-modules="nvidia-dkms-440-server (= $(dkms_nvidia_440_server_version))"
+gencontrol_flags += -Vdkms:nvidia-450-server-modules="nvidia-dkms-450-server (= $(dkms_nvidia_450_server_version))"
 
 gencontrol_flags += -Vnvk:nvidia-390="nvidia-kernel-common-390 (<= $(nvidia_390_upstream_version)-1), nvidia-kernel-common-390 (>= $(nvidia_390_upstream_version))"
 gencontrol_flags += -Vnvk:nvidia-435="nvidia-kernel-common-435 (<= $(nvidia_435_upstream_version)-1), nvidia-kernel-common-435 (>= $(nvidia_435_upstream_version))"
-gencontrol_flags += -Vnvk:nvidia-440="nvidia-kernel-common-440 (<= $(nvidia_440_upstream_version)-1), nvidia-kernel-common-440 (>= $(nvidia_440_upstream_version))"
+gencontrol_flags += -Vnvk:nvidia-450="nvidia-kernel-common-450 (<= $(nvidia_450_upstream_version)-1), nvidia-kernel-common-450 (>= $(nvidia_450_upstream_version))"
 gencontrol_flags += -Vnvk:nvidia-418-server="nvidia-kernel-common-418-server (<= $(nvidia_418_server_upstream_version)-1), nvidia-kernel-common-418-server (>= $(nvidia_418_server_upstream_version))"
 gencontrol_flags += -Vnvk:nvidia-440-server="nvidia-kernel-common-440-server (<= $(nvidia_440_server_upstream_version)-1), nvidia-kernel-common-440-server (>= $(nvidia_440_server_upstream_version))"
+gencontrol_flags += -Vnvk:nvidia-450-server="nvidia-kernel-common-450-server (<= $(nvidia_450_server_upstream_version)-1), nvidia-kernel-common-450-server (>= $(nvidia_450_server_upstream_version))"
 
 override_dh_gencontrol:
 	dh_gencontrol -- $(gencontrol_flags)