diff --git a/debian/control.d/transitionals-hwe-20.04 b/debian/control.d/transitionals-hwe-20.04
new file mode 100644
index 0000000000..20a1c62c6b
--- /dev/null
+++ b/debian/control.d/transitionals-hwe-20.04
@@ -0,0 +1,270 @@
+#
+# Generated using kteam-tools script:
+# generate-transitions --input debian/control --output debian/control.d/transitionals-hwe-20.04 hwe-20.04 hwe-22.04
+#
+Package: linux-headers-generic-hwe-20.04
+Architecture: amd64 armhf arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-headers-generic-hwe-22.04
+Description: Generic Linux kernel headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-generic-hwe-20.04
+Architecture: amd64 armhf arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-image-generic-hwe-22.04
+Description: Generic Linux kernel image (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-generic-hwe-20.04
+Architecture: amd64 armhf arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-tools-generic-hwe-22.04
+Description: Generic Linux kernel tools (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-cloud-tools-generic-hwe-20.04
+Architecture: amd64
+Section: oldlibs
+Depends: linux-cloud-tools-generic-hwe-22.04
+Description: Generic Linux kernel cloud tools (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-generic-hwe-20.04
+Architecture: amd64 armhf arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-generic-hwe-22.04
+Description: Complete Generic Linux kernel and headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-headers-generic-hwe-20.04-edge
+Architecture: amd64 armhf arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-headers-generic-hwe-22.04-edge
+Description: Generic Linux kernel headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-generic-hwe-20.04-edge
+Architecture: amd64 armhf arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-image-generic-hwe-22.04-edge
+Description: Generic Linux kernel image (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-generic-hwe-20.04-edge
+Architecture: amd64 armhf arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-tools-generic-hwe-22.04-edge
+Description: Generic Linux kernel tools (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-cloud-tools-generic-hwe-20.04-edge
+Architecture: amd64
+Section: oldlibs
+Depends: linux-cloud-tools-generic-hwe-22.04-edge
+Description: Generic Linux kernel cloud tools (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-generic-hwe-20.04-edge
+Architecture: amd64 armhf arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-generic-hwe-22.04-edge
+Description: Complete Generic Linux kernel and headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-headers-generic-64k-hwe-20.04
+Architecture: arm64
+Section: oldlibs
+Depends: linux-headers-generic-64k-hwe-22.04
+Description: Generic 64K Linux kernel headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-generic-64k-hwe-20.04
+Architecture: arm64
+Section: oldlibs
+Depends: linux-image-generic-64k-hwe-22.04
+Description: Generic 64K Linux kernel image (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-generic-64k-hwe-20.04
+Architecture: arm64
+Section: oldlibs
+Depends: linux-tools-generic-64k-hwe-22.04
+Description: Generic 64K Linux kernel tools (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-generic-64k-hwe-20.04
+Architecture: arm64
+Section: oldlibs
+Depends: linux-generic-64k-hwe-22.04
+Description: Complete Generic 64K Linux kernel and headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-headers-generic-64k-hwe-20.04-edge
+Architecture: arm64
+Section: oldlibs
+Depends: linux-headers-generic-64k-hwe-22.04-edge
+Description: Generic 64K Linux kernel headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-generic-64k-hwe-20.04-edge
+Architecture: arm64
+Section: oldlibs
+Depends: linux-image-generic-64k-hwe-22.04-edge
+Description: Generic 64K Linux kernel image (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-generic-64k-hwe-20.04-edge
+Architecture: arm64
+Section: oldlibs
+Depends: linux-tools-generic-64k-hwe-22.04-edge
+Description: Generic 64K Linux kernel tools (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-generic-64k-hwe-20.04-edge
+Architecture: arm64
+Section: oldlibs
+Depends: linux-generic-64k-hwe-22.04-edge
+Description: Complete Generic 64K Linux kernel and headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-headers-generic-lpae-hwe-20.04
+Architecture: armhf
+Section: oldlibs
+Depends: linux-headers-generic-lpae-hwe-22.04
+Description: Generic LPAE Linux kernel headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-generic-lpae-hwe-20.04
+Architecture: armhf
+Section: oldlibs
+Depends: linux-image-generic-lpae-hwe-22.04
+Description: Generic LPAE Linux kernel image (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-generic-lpae-hwe-20.04
+Architecture: armhf
+Section: oldlibs
+Depends: linux-tools-generic-lpae-hwe-22.04
+Description: Generic LPAE Linux kernel tools (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-generic-lpae-hwe-20.04
+Architecture: armhf
+Section: oldlibs
+Depends: linux-generic-lpae-hwe-22.04
+Description: Complete Generic LPAE Linux kernel and headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-headers-generic-lpae-hwe-20.04-edge
+Architecture: armhf
+Section: oldlibs
+Depends: linux-headers-generic-lpae-hwe-22.04-edge
+Description: Generic LPAE Linux kernel headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-generic-lpae-hwe-20.04-edge
+Architecture: armhf
+Section: oldlibs
+Depends: linux-image-generic-lpae-hwe-22.04-edge
+Description: Generic LPAE Linux kernel image (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-generic-lpae-hwe-20.04-edge
+Architecture: armhf
+Section: oldlibs
+Depends: linux-tools-generic-lpae-hwe-22.04-edge
+Description: Generic LPAE Linux kernel tools (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-generic-lpae-hwe-20.04-edge
+Architecture: armhf
+Section: oldlibs
+Depends: linux-generic-lpae-hwe-22.04-edge
+Description: Complete Generic LPAE Linux kernel and headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-headers-virtual-hwe-20.04
+Architecture: amd64 arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-headers-virtual-hwe-22.04
+Description: Virtual Linux kernel headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-virtual-hwe-20.04
+Architecture: amd64 arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-image-virtual-hwe-22.04
+Description: Virtual Linux kernel image (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-virtual-hwe-20.04
+Architecture: amd64 arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-tools-virtual-hwe-22.04
+Description: Virtual Linux kernel tools (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-cloud-tools-virtual-hwe-20.04
+Architecture: amd64
+Section: oldlibs
+Depends: linux-cloud-tools-virtual-hwe-22.04
+Description: Virtual Linux kernel cloud tools (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-virtual-hwe-20.04
+Architecture: amd64 arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-virtual-hwe-22.04
+Description: Minimal Generic Linux kernel and headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-extra-virtual-hwe-20.04
+Architecture: amd64 arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-image-extra-virtual-hwe-22.04
+Description: Extra drivers for Virtual Linux kernel image (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-headers-virtual-hwe-20.04-edge
+Architecture: amd64 arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-headers-virtual-hwe-22.04-edge
+Description: Virtual Linux kernel headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-virtual-hwe-20.04-edge
+Architecture: amd64 arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-image-virtual-hwe-22.04-edge
+Description: Virtual Linux kernel image (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-tools-virtual-hwe-20.04-edge
+Architecture: amd64 arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-tools-virtual-hwe-22.04-edge
+Description: Virtual Linux kernel tools (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-cloud-tools-virtual-hwe-20.04-edge
+Architecture: amd64
+Section: oldlibs
+Depends: linux-cloud-tools-virtual-hwe-22.04-edge
+Description: Virtual Linux kernel cloud tools (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-virtual-hwe-20.04-edge
+Architecture: amd64 arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-virtual-hwe-22.04-edge
+Description: Minimal Generic Linux kernel and headers (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+
+Package: linux-image-extra-virtual-hwe-20.04-edge
+Architecture: amd64 arm64 powerpc ppc64el s390x
+Section: oldlibs
+Depends: linux-image-extra-virtual-hwe-22.04-edge
+Description: Extra drivers for Virtual Linux kernel image (dummy transitional package)
+ Transitional package for upgrades. This package can be safely removed.
+